//                                                                             ;
//                     L-Clock Plugin for Talisman 2                           ;
//                            version 1.0                                      ;
//                                                                             ;
//     This is freeware example of Talisman's plugin                           ;
//     Lighttek Software , http://www.lighttek.com                             ;
//                                                                             ;
//                                                                             ;


unit lvol;

interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, inifiles,
  ExtCtrls, Controls,Dialogs,shellapi,messages ;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  private
    { Private declarations }
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  homepath: string;
  align_ind,lft_temp, tp_temp,h_temp,w_temp:integer;  //  variables for align procedure
  cl_cx,cl_cy,cl_r1,cl_r2,cl_r3:integer; // clock center x,y, radius min, radius hour
  back1:tbitmap;                         // background image
  w_1,w_2,w_3:integer;                   // width of arrows
  hcolor,mcolor,scolor:integer;          // colors of arrows
  locked: boolean;                       // lock-unlock form
  procedure aligncontrol_form(lft,tp,wdth,hght,basewidth,baseheight,il,it,ir,ib,align_ind:integer);
implementation

{$R *.DFM}


//         Creating of a non-rectangular window.

function BitmapToRgn(Bitmap: TBitmap; TransColor: TColor): HRGN;
const
  AllocUnit = 100;

var
  BMP: TBitmap;
  MaxRects,mr: Integer;
  HData: HGlobal;
  PData: PRgnData;
  CB, CR, CG, LR, LG, LB: Byte;
  P32: Pointer;
  X, X0, Y: Integer;
  P: PLongInt;
  PR: PRect;
  H: Hrgn;
begin
  Result:=0;
  BMP:=TBitmap.Create;
  BMP.Assign(Bitmap);
  BMP.HandleType:=bmDIB;
  BMP.PixelFormat:=pf32bit;
  MaxRects:=AllocUnit;
  HData:=GlobalAlloc(GMem_Moveable, SizeOf(TRgnDataHeader) + SizeOf(TRect) * MaxRects);
  PData := GlobalLock(HData);
  PData^.RDH.dwSize:=SizeOf(TRgnDataHeader);
  PData^.RDH.iType:=RDH_Rectangles;
  PData^.RDH.nCount:=0;
  PData^.RDH.nRgnSize:=0;
  SetRect(PData^.RDH.rcBound, MaxInt, MaxInt, 0, 0);
  LR:=GetRValue(ColorToRGB(TransColor));
  LG:=GetGValue(ColorToRGB(TransColor));
  LB:=GetBValue(ColorToRGB(TransColor));
  for Y:=0 to Bitmap.Height - 1 do begin
    X:=-1;
    P32:=BMP.ScanLine[Y];
    while (X + 1) < Bitmap.Width do begin
      Inc(X);
      X0:=X;
      P:=PLongInt(P32);
      Inc(PChar(P), X * SizeOf(LongInt));
      while X<Bitmap.Width do begin
        CR:=GetBValue(P^);
        CG:=GetGValue(P^);
        CB:=GetRValue(P^);
        if ((CR = LR) and (CG = LG) and (CB = LB)) xor False then  // invert
          Break;
        Inc(PChar(P), SizeOf(LongInt));
        Inc(X);
      end;
      if X > X0 then begin
        mr:= PData^.RDH.nCount;
        if mr >= MaxRects then begin
          GlobalUnlock(HData);
          Inc(MaxRects, AllocUnit);
          HData:=GlobalReAlloc(HData, SizeOf(TRgnDataHeader) + SizeOf(TRect) * MaxRects, GMem_Moveable);
          PData:=GlobalLock(HData);
        end;
        PR:=@PData^.Buffer[PData^.RDH.nCount * SizeOf(TRect)];
        SetRect(PR^, X0, Y, X, Y + 1);
        if X0 < PData^.RDH.rcBound.Left then
          PData^.RDH.rcBound.Left:=X0;
        if Y < PData^.RDH.rcBound.Top then
          PData^.RDH.rcBound.Top:=Y;
        if X > PData^.RDH.rcBound.Right then
          PData^.RDH.rcBound.Left:=X;
        if Y + 1 > PData^.RDH.rcBound.Bottom then
          PData^.RDH.rcBound.Bottom:=Y + 1;
        Inc(PData^.RDH.nCount);
        if PData^.RDH.nCount = 2000 then begin
          H:=ExtCreateRegion(nil, SizeOf(TRgnDataHeader) + (SizeOf(TRect) * MaxRects), PData^);
          if Result<>0 then begin
            CombineRgn(Result, Result, H, RGN_OR);
            DeleteObject(H);
          end else
            Result:=H;
          PData^.RDH.nCount:=0;
          SetRect(PData^.RDH.rcBound,MaxInt,MaxInt,0,0);
        end;
      end;
    end;
  end;
  H:=ExtCreateRegion(nil, SizeOf(TRgnDataHeader) + (SizeOf(TRect) * MaxRects), PData^);
  if Result <> 0 then begin
    CombineRgn(Result, Result, H, RGN_OR);
    DeleteObject(H);
  end else
    Result:=H;
  GlobalFree(HData);
  BMP.Free
end;


procedure TForm1.FormShow(Sender: TObject);
var tlhandle,phandle: thandle;
begin
//  Find Talisman's window
tlhandle:=findwindow('TForm1','Talisman');
if   tlhandle=0 then begin showmessage('Talisman Desktop not found!');exit;end;
phandle:=findwindow('TForm1','lclock');
// insert the clock in Talisman
if (tlhandle<>0) and (phandle<>0) then windows.SetParent(phandle,tlhandle);
ShowWindow(Application.Handle,sw_Hide);
end;


procedure TForm1.FormCreate(Sender: TObject);
var ifile: tinifile;il,it,ir,ib:integer;Result: HRGN;
begin
homepath:=extractfilepath(paramstr(0));
image1.align:=alclient;
ifile:=tinifile.create(homepath+'lclock.ini');
back1:=tbitmap.create;
if fileexists(homepath+'lclock.bmp')then
begin
image1.Picture.loadfromfile(homepath+'lclock.bmp');
back1.loadfromfile(homepath+'lclock.bmp');
end
else
begin
back1.width:=80; back1.height:=80;back1.canvas.fillrect(rect(0,0,80,80));
image1.picture.bitmap.assign(back1);
end;

image1.Picture.bitmap.pixelformat:=pf24bit;
back1.pixelformat:=pf24bit;

form1.width:=back1.width;
form1.height:=back1.height;
form1.left:=ifile.readinteger('plugin','xf',20);
form1.top:=ifile.readinteger('plugin','yf',20);

cl_cx:=ifile.readinteger('plugin','center x',40);
cl_cy:=ifile.readinteger('plugin','center y',40);
cl_r1:=ifile.readinteger('plugin','radius hour',20);
cl_r2:=ifile.readinteger('plugin','radius minute',30);
cl_r3:=ifile.readinteger('plugin','radius second',35);

w_1:=ifile.readinteger('plugin','width hour',2);
w_2:=ifile.readinteger('plugin','width minute',1);
w_3:=ifile.readinteger('plugin','width second',1);

// il,ir,it,ib - indents of form from left,top,right,bottom of screen
// These variables are not used in the LClock project
il:=0;it:=0;ir:=0;ib:=0;


hcolor:=ifile.readinteger('plugin','hour color',0);
mcolor:=ifile.readinteger('plugin','min color',0);
scolor:=ifile.readinteger('plugin','sec color',0);
locked:=ifile.readbool('plugin','locked',false);
align_ind:=ifile.readinteger('plugin','alignf',0);
aligncontrol_form(form1.left,form1.top,form1.width,form1.height,screen.width,screen.height,il,it,ir,ib,align_ind);
form1.width:=w_temp;
form1.height:=h_temp;
form1.left:=lft_temp;
form1.top:=tp_temp;
ifile.free;
//   set transparent form
Result:=BitmapToRgn(Image1.picture.bitmap, $ff00ff);
SetWindowRgn(Handle, Result, True);
end;

//  Calculate window size and position
procedure aligncontrol_form(lft,tp,wdth,hght,basewidth,baseheight,il,it,ir,ib,align_ind:integer);
var al_:integer;
begin
        al_:=align_ind;
        if align_ind>=32 then begin align_ind:=align_ind-32;hght:=baseheight;end;
        if align_ind>=16 then begin align_ind:=align_ind-16;wdth:=basewidth;end;
        case align_ind of
        1: lft:=lft;
        2: lft:=lft;
        3: lft:=lft;
        4: lft:=basewidth-wdth-lft;
        5: begin lft:=round((basewidth-wdth)/2);end;
        6: begin lft:=basewidth-wdth-lft; end;
        7: begin lft:=round((basewidth-wdth)/2); end;
        8: tp:=baseheight-hght-tp;
        9:begin tp:=baseheight-hght-tp end;
        10:begin tp:=round((baseheight-hght)/2); end;
        11:begin tp:=round((baseheight-hght)/2); end;
        12:begin tp:=baseheight-hght-tp;lft:=basewidth-wdth-lft;end;
        13:begin lft:=round((basewidth-wdth)/2);tp:=baseheight-hght-tp;end;
        14:begin tp:=round((baseheight-hght)/2);lft:=basewidth-wdth-lft;end;
        15:begin lft:=round((basewidth-wdth)/2);tp:=round((baseheight-hght)/2);end;
        end;
        if al_>=32 then  begin al_:=al_-32;tp:=0+it;hght:=hght-ib-it;end;
        if al_>=16 then begin lft:=0+il;wdth:=wdth-il-ir; end;
        lft_temp:=lft;
        tp_temp:=tp;
        h_temp:=hght;
        w_temp:=wdth;
end;


procedure TForm1.FormDestroy(Sender: TObject);
var ifile: tinifile;
begin
//  save position
ifile:=tinifile.create(homepath+'lclock.ini');
aligncontrol_form(form1.left,form1.top,form1.width,form1.height,screen.width,screen.height,0,0,0,0,align_ind);
ifile.writeinteger('plugin','xf',lft_temp);
ifile.writeinteger('plugin','yf',tp_temp);
ifile.free;
// clear bitmap
back1.free;
end;



procedure TForm1.Timer1Timer(Sender: TObject);
var   Present: TDateTime; Year, Month, Day, Hour, Min, Sec, MSec: Word;
ugol:real;
begin
Image1.Picture.bitmap.canvas.draw(0,0,back1);
  Present:= Now;
  //DecodeDate(Present, Year, Month, Day);
  DecodeTime(Present, Hour, Min, Sec, MSec);

//  draw arrows
with image1.canvas do
     begin

     MoveTo(cl_cx, cl_cy);
     image1.canvas.pen.color:=scolor ;
     image1.canvas.pen.width:=w_3;
     ugol:=(2*Pi/60)*sec-(pi/2) ;
     lineto(round(cos(ugol)*cl_r3)+cl_cx,round(sin(ugol)*cl_r3)+cl_cy);

     MoveTo(cl_cx, cl_cy);
     image1.canvas.pen.color:=hcolor;
     image1.canvas.pen.width:=w_1;
     ugol:=(2*Pi/12)*hour-(pi/2) ;
     lineto(round(cos(ugol)*cl_r1)+cl_cx,round(sin(ugol)*cl_r1)+cl_cy);

     MoveTo(cl_cx, cl_cy);
     image1.canvas.pen.color:=mcolor;
     image1.canvas.pen.width:=w_2;
     ugol:=(2*Pi/60)*min-(pi/2) ;
     lineto(round(cos(ugol)*cl_r2)+cl_cx,round(sin(ugol)*cl_r2)+cl_cy);

     end;
end;

//  move form
procedure TForm1.WMNCHitTest(var M: TWMNCHitTest);
begin
  if locked then exit;
  inherited; if  M.Result = htClient then M.Result := htCaption;
end;


end.
